## duperemove 0.11

=== Makefile ===
VER=0.11.beta4
RELEASE=v$(VER)

CC ?= gcc
CFLAGS ?= -Wall -ggdb -O2

MANPAGES=duperemove.8 btrfs-extent-same.8 hashstats.8 show-shared-extents.8

HEADERS=csum.h hash-tree.h results-tree.h kernel.h list.h rbtree.h dedupe.h \
	btrfs-ioctl.h filerec.h btrfs-util.h debug.h util.h \
	memstats.h file_scan.h find_dupes.h run_dedupe.h xxhash.h \
	bswap.h dbfile.h interval_tree.h interval_tree_generic.h \
	rbtree_augmented.h list_sort.h stats.h
CFILES=duperemove.c hash-tree.c results-tree.c rbtree.c dedupe.c filerec.c \
	btrfs-util.c util.c memstats.c file_scan.c find_dupes.c run_dedupe.c \
	csum.c dbfile.c interval_tree.c list_sort.c stats.c debug.c
hash_CFILES=csum-xxhash.c xxhash.c csum-murmur3.c

CFILES += $(hash_CFILES)

hashstats_CFILES=hashstats.c
btrfs_extent_same_CFILES=btrfs-extent-same.c
csum_test_CFILES=csum-test.c

DIST_CFILES:=$(CFILES) $(hashstats_CFILES) $(btrfs_extent_same_CFILES) \
	$(csum_test_CFILES)
DIST_SOURCES:=$(DIST_CFILES) $(HEADERS) LICENSE LICENSE.xxhash Makefile \
	rbtree.txt README.md $(MANPAGES) SubmittingPatches docs/duperemove.html
DIST=duperemove-$(VER)
DIST_TARBALL=$(RELEASE).tar.gz
TEMP_INSTALL_DIR:=$(shell mktemp -du -p .)

objects = $(CFILES:.c=.o)

hash_obj=$(hash_CFILES:.c=.o)
hashstats_obj = $(hash_obj) rbtree.o hash-tree.o filerec.o util.o \
	results-tree.o csum.o dbfile.o interval_tree.o list_sort.o debug.o
show_shared_obj = rbtree.o util.o debug.o
csum_test_obj = $(hash_obj) util.o csum.o debug.o

install_progs = duperemove hashstats btrfs-extent-same show-shared-extents
progs = $(install_progs) csum-test

glib_CFLAGS=$(shell pkg-config --cflags glib-2.0)
glib_LIBS=$(shell pkg-config --libs glib-2.0)
sqlite_CFLAGS=$(shell pkg-config --cflags sqlite3)
sqlite_LIBS=$(shell pkg-config --libs sqlite3)

ifdef DEBUG
	DEBUG_FLAGS = -ggdb3 -fsanitize=address -fno-omit-frame-pointer	\
			-DDEBUG_BUILD
endif
override CFLAGS += -D_FILE_OFFSET_BITS=64 -DVERSTRING=\"$(RELEASE)\" \
	$(hash_CFLAGS) $(glib_CFLAGS) $(sqlite_CFLAGS) -rdynamic $(DEBUG_FLAGS)
LIBRARY_FLAGS += $(hash_LIBS) $(glib_LIBS) $(sqlite_LIBS) -lm

# make C=1 to enable sparse
ifdef C
	check = sparse -D__CHECKER__ -D__CHECK_ENDIAN__ -Wbitwise \
		-Wuninitialized -Wshadow -Wundef
else
	check = @true
endif

DESTDIR ?= /
PREFIX ?= /usr/local
SHAREDIR = $(PREFIX)/share
SBINDIR = $(PREFIX)/sbin
MANDIR = $(SHAREDIR)/man

.c.o:
	$(check) $(CPPFLAGS) $(CFLAGS) -c $< -o $@ $(LIBRARY_FLAGS)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -c $< -o $@ $(LIBRARY_FLAGS)

all: $(progs)
debug:
	@echo "Deprecated, use \"make DEBUG=1\" instead please."

#TODO: Replace this with an auto-dependency
$(objects): $(HEADERS)
duperemove: $(objects)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(objects) -o duperemove $(LIBRARY_FLAGS)

tarball: clean
	mkdir -p $(TEMP_INSTALL_DIR)/$(DIST)
	cp $(DIST_SOURCES) $(TEMP_INSTALL_DIR)/$(DIST)
	tar -C $(TEMP_INSTALL_DIR) -zcf $(DIST_TARBALL) $(DIST)
	rm -fr $(TEMP_INSTALL_DIR)

btrfs-extent-same: btrfs-extent-same.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o btrfs-extent-same btrfs-extent-same.c

install: $(install_progs) $(MANPAGES)
	mkdir -p -m 0755 $(DESTDIR)$(SBINDIR)
	for prog in $(install_progs); do \
		install -m 0755 $$prog $(DESTDIR)$(SBINDIR); \
	done
	mkdir -p -m 0755 $(DESTDIR)$(MANDIR)/man8
	for man in $(MANPAGES); do \
		install -m 0644 $$man $(DESTDIR)$(MANDIR)/man8; \
	done

csum-test: $(csum_test_obj) csum-test.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(csum_test_obj) -o csum-test csum-test.c  $(LIBRARY_FLAGS)

show-shared-extents: $(show_shared_obj) filerec.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -DFILEREC_TEST filerec.c $(show_shared_obj) -o show-shared-extents $(LIBRARY_FLAGS)

hashstats: $(hashstats_obj) hashstats.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(hashstats_obj) hashstats.c -o hashstats $(LIBRARY_FLAGS)

clean:
	rm -fr $(objects) $(progs) $(DIST_TARBALL) btrfs-extent-same filerec-test show-shared-extents hashstats csum-*.o *~

=== debian/changelog ===
duperemove (0.11-1) unstable; urgency=medium

  * Bump to latest release
  * Description change
  * Add patch to change binaries path from sbin to bin (Closes: #849759)
  * Cherry-pick O_RDONLY for root from kilobyte

 -- Peter Záhradník <peter.zahradnik@znik.sk>  Sat, 31 Dec 2016 09:07:28 +0000

duperemove (0.11~beta4-1) unstable; urgency=low

  * Initial release. (Closes: #784856)

 -- Peter Záhradník <peter.zahradnik@znik.sk>  Wed, 28 Sep 2016 13:38:07 +0100

=== debian/control ===
Source: duperemove
Maintainer: Peter Záhradník <peter.zahradnik@znik.sk>
Section: admin
Priority: optional
Build-Depends: debhelper (>= 9), libglib2.0-dev, libgcrypt20-dev, libsqlite3-dev
Standards-Version: 3.9.8
Homepage: https://github.com/markfasheh/duperemove
Vcs-Git: https://github.com/petzah/duperemove.git
Vcs-Browser: https://github.com/petzah/duperemove.git

Package: duperemove
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: extent-based deduplicator for file systems
 Duperemove is a tool for finding duplicated extents and submitting them for
 deduplication.  When given a list of files it will hash their contents on a
 block by block basis and compare those hashes to each other, finding and
 categorizing extents that match each other.
 .
 On BTRFS and, experimentally, XFS, it can then reflink such extents in a
 race-free way.  Unlike hardlink-based solutions, affected files appear
 independent in any way other than reduced disk space used.

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/duperemove-$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
  https://github.com/markfasheh/duperemove/tags .*/v?(\d\S*)\.tar\.gz

## duperemove 0.11.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VER=0.11.beta4
+VER=0.11.1
 RELEASE=v$(VER)
 
 CC ?= gcc
@@ -52,7 +52,8 @@
 endif
 override CFLAGS += -D_FILE_OFFSET_BITS=64 -DVERSTRING=\"$(RELEASE)\" \
 	$(hash_CFLAGS) $(glib_CFLAGS) $(sqlite_CFLAGS) -rdynamic $(DEBUG_FLAGS)
-LIBRARY_FLAGS += $(hash_LIBS) $(glib_LIBS) $(sqlite_LIBS) -lm
+LIBRARY_FLAGS += -Wl,--as-needed -latomic -lm
+LIBRARY_FLAGS += $(hash_LIBS) $(glib_LIBS) $(sqlite_LIBS)
 
 # make C=1 to enable sparse
 ifdef C
@@ -100,6 +101,14 @@
 		install -m 0644 $$man $(DESTDIR)$(MANDIR)/man8; \
 	done
 
+uninstall:
+	for prog in $(install_progs); do \
+		rm -f $(DESTDIR)$(SBINDIR)/$$prog; \
+	done
+	for man in $(MANPAGES); do \
+		rm -f $(DESTDIR)$(MANDIR)/man8/$$man; \
+	done
+
 csum-test: $(csum_test_obj) csum-test.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(csum_test_obj) -o csum-test csum-test.c  $(LIBRARY_FLAGS)

=== debian/changelog ===
duperemove (0.11.1-3) unstable; urgency=medium

  * Add cross.patch (Closes: #918500)
  * Re-format patches (gbp pq import => export)

 -- Peter Záhradník <peter.zahradnik@znik.sk>  Thu, 10 Jan 2019 13:18:07 +0000

duperemove (0.11.1-2) unstable; urgency=medium

  * Update Standards-Version to 4.3.0
  * Update Build-Depends

 -- Peter Záhradník <peter.zahradnik@znik.sk>  Tue, 25 Dec 2018 09:53:40 +0000

duperemove (0.11.1-1) unstable; urgency=medium

  * Update Standards-Version
  * Bump debian/compat to 11
  * Update debian/watch
  * Fix insecure-copyright-format-uri
  * Move Vcs from github.com to salsa.debian.org
  * Add Enhances: btrfs-progs (Closes: #854361)
  * Bump to upstream v0.11.1
  * Fix FTBFS for mips/mipsel arch (Closes: #851261)
  * Fix missing include in dbfile.c / FTBFS (Closes: #916104)

 -- Peter Záhradník <peter.zahradnik@znik.sk>  Wed, 19 Dec 2018 11:00:10 +0000

duperemove (0.11-2) unstable; urgency=medium

  * Bump to latest (Closes: #851261)

 -- Peter Záhradník <peter.zahradnik@znik.sk>  Fri, 03 Feb 2017 11:28:07 +0000

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,17 @@
 Maintainer: Peter Záhradník <peter.zahradnik@znik.sk>
 Section: admin
 Priority: optional
-Build-Depends: debhelper (>= 9), libglib2.0-dev, libgcrypt20-dev, libsqlite3-dev
-Standards-Version: 3.9.8
-Homepage: https://github.com/markfasheh/duperemove
-Vcs-Git: https://github.com/petzah/duperemove.git
-Vcs-Browser: https://github.com/petzah/duperemove.git
+Build-Depends: debhelper (>= 11~), libglib2.0-dev, libsqlite3-dev
+Standards-Version: 4.3.0
+Homepage: https://markfasheh.github.io/duperemove/
+Vcs-Git: https://salsa.debian.org/petzah-guest/duperemove.git
+Vcs-Browser: https://salsa.debian.org/petzah-guest/duperemove
 
 Package: duperemove
 Architecture: linux-any
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Enhances: btrfs-progs
 Description: extent-based deduplicator for file systems
  Duperemove is a tool for finding duplicated extents and submitting them for
  deduplication.  When given a list of files it will hash their contents on a

=== debian/watch ===
version=4
opts= \
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/duperemove-$1\.tar\.gz/,\
pgpsigurlmangle=s/archive\/v?(\d\S+)\.tar\.gz/releases\/download\/v$1\/v$1\.tar\.gz\.asc/,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
  https://github.com/markfasheh/duperemove/tags .*/v?(\d\S+)\.tar\.gz

## duperemove 0.11.2

=== Makefile ===
--- 
+++ 
@@ -1,20 +1,20 @@
-VER=0.11.1
+VER=0.12.dev
 RELEASE=v$(VER)
 
 CC ?= gcc
-CFLAGS ?= -Wall -ggdb -O2
+CFLAGS ?= -Wall -ggdb
 
 MANPAGES=duperemove.8 btrfs-extent-same.8 hashstats.8 show-shared-extents.8
 
 HEADERS=csum.h hash-tree.h results-tree.h kernel.h list.h rbtree.h dedupe.h \
-	btrfs-ioctl.h filerec.h btrfs-util.h debug.h util.h \
-	memstats.h file_scan.h find_dupes.h run_dedupe.h xxhash.h \
+	ioctl.h filerec.h btrfs-util.h debug.h util.h \
+	memstats.h file_scan.h find_dupes.h run_dedupe.h xxhash.h  xxh3.h \
 	bswap.h dbfile.h interval_tree.h interval_tree_generic.h \
 	rbtree_augmented.h list_sort.h stats.h
 CFILES=duperemove.c hash-tree.c results-tree.c rbtree.c dedupe.c filerec.c \
 	btrfs-util.c util.c memstats.c file_scan.c find_dupes.c run_dedupe.c \
 	csum.c dbfile.c interval_tree.c list_sort.c stats.c debug.c
-hash_CFILES=csum-xxhash.c xxhash.c csum-murmur3.c
+hash_CFILES=csum-xxhash.c csum-murmur3.c
 
 CFILES += $(hash_CFILES)
 
@@ -47,12 +47,15 @@
 sqlite_LIBS=$(shell pkg-config --libs sqlite3)
 
 ifdef DEBUG
-	DEBUG_FLAGS = -ggdb3 -fsanitize=address -fno-omit-frame-pointer	\
-			-DDEBUG_BUILD
+	DEBUG_FLAGS = -ggdb3 -fsanitize=address -fno-omit-frame-pointer	-O0 \
+			-DDEBUG_BUILD -DSQLITE_DEBUG -DSQLITE_MEMDEBUG \
+			-DSQLITE_ENABLE_EXPLAIN_COMMENTS -fsanitize-address-use-after-scope
+else
+	CFLAGS += -O2
 endif
+
 override CFLAGS += -D_FILE_OFFSET_BITS=64 -DVERSTRING=\"$(RELEASE)\" \
 	$(hash_CFLAGS) $(glib_CFLAGS) $(sqlite_CFLAGS) -rdynamic $(DEBUG_FLAGS)
-LIBRARY_FLAGS += -Wl,--as-needed -latomic -lm
 LIBRARY_FLAGS += $(hash_LIBS) $(glib_LIBS) $(sqlite_LIBS)
 
 # make C=1 to enable sparse
@@ -69,9 +72,13 @@
 SBINDIR = $(PREFIX)/sbin
 MANDIR = $(SHAREDIR)/man
 
-.c.o:
-	$(check) $(CPPFLAGS) $(CFLAGS) -c $< -o $@ $(LIBRARY_FLAGS)
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -c $< -o $@ $(LIBRARY_FLAGS)
+%.c.i: FORCE
+	$(check) $(CPPFLAGS) $(CFLAGS) -c $(subst .i,,$@) -o $@ $(LIBRARY_FLAGS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -E $(subst .i,,$@) -o $@ $(LIBRARY_FLAGS)
+
+%.c.o: FORCE
+	$(check) $(CPPFLAGS) $(CFLAGS) -c $(subst .o,,$@) -o $@ $(LIBRARY_FLAGS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -c  $(subst .o,,$@) -o $@ $(LIBRARY_FLAGS)
 
 all: $(progs)
 debug:
@@ -120,3 +127,5 @@
 
 clean:
 	rm -fr $(objects) $(progs) $(DIST_TARBALL) btrfs-extent-same filerec-test show-shared-extents hashstats csum-*.o *~
+
+FORCE:

=== debian/changelog ===
duperemove (0.11.2-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:46:42 +1100

duperemove (0.11.2-3build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:15:04 +0000

duperemove (0.11.2-3) unstable; urgency=medium

  * Add some DEP-3 headers for bin/sbin patch
  * Add version string patch
  * Add latomic patch from upstream and remove debian/rules condition

 -- Peter Záhradník <peter.zahradnik@znik.sk>  Thu, 21 Jan 2021 21:33:34 +0000

duperemove (0.11.2-2) unstable; urgency=medium

  * update debian/rules for armel and mipsel to use -latomic

 -- Peter Záhradník <peter.zahradnik@znik.sk>  Wed, 20 Jan 2021 12:55:09 +0000

duperemove (0.11.2-1) unstable; urgency=medium

  * Bump version
  * Update compat, debhelper, standards, copyright
  * Drop patches which were included in upstream/kernel

 -- Peter Záhradník <peter.zahradnik@znik.sk>  Sat, 16 Jan 2021 20:58:34 +0000

duperemove (0.11.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix ftbfs with GCC-10. (Closes: #957152)
    - Use upstream patch.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 25 Aug 2020 19:37:15 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: duperemove
-Maintainer: Peter Záhradník <peter.zahradnik@znik.sk>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Peter Záhradník <peter.zahradnik@znik.sk>
 Section: admin
 Priority: optional
-Build-Depends: debhelper (>= 11~), libglib2.0-dev, libsqlite3-dev
-Standards-Version: 4.3.0
+Build-Depends: debhelper-compat (= 13), libglib2.0-dev, libsqlite3-dev
+Standards-Version: 4.5.1
+Rules-Requires-Root: binary-targets
 Homepage: https://markfasheh.github.io/duperemove/
-Vcs-Git: https://salsa.debian.org/petzah-guest/duperemove.git
-Vcs-Browser: https://salsa.debian.org/petzah-guest/duperemove
+Vcs-Git: https://salsa.debian.org/petzah/duperemove.git
+Vcs-Browser: https://salsa.debian.org/petzah/duperemove
 
 Package: duperemove
 Architecture: linux-any

## duperemove 0.15.2

=== Makefile ===
VERSION ?= $(shell git describe --abbrev=4 --dirty --always --tags;)
IS_RELEASE ?= $(if $(filter $(shell git rev-list $(shell git describe --abbrev=0 --tags --exclude '*dev';)..HEAD --count;),0),1,0)

CC ?= gcc
CFLAGS ?= -Wall -ggdb -std=gnu11 -Werror=strict-prototypes -MMD
PKG_CONFIG ?= pkg-config

MANPAGES=duperemove.8 btrfs-extent-same.8 hashstats.8 show-shared-extents.8
ZSH_COMPLETION=completion/zsh/_duperemove

# tests.c is ulgy: it includes lots of c files, to get access to inlined code
CFILES = $(filter-out tests.c,$(wildcard *.c))
DEPENDS := $(CFILES:.c=.d)
OBJECTS := $(CFILES:.c=.o)
install_progs = duperemove hashstats btrfs-extent-same
progs = $(install_progs) csum-test
PROGS_OBJECTS := $(addsuffix .o,$(basename $(progs)))
SHARED_OBJECTS := $(filter-out $(PROGS_OBJECTS),$(OBJECTS))

DIST_SOURCES:=$(CFILES) $(wildcard *.h) LICENSE Makefile \
	rbtree.txt README.md $(MANPAGES) SubmittingPatches docs/duperemove.html
DIST=duperemove-$(VERSION)
DIST_TARBALL=$(VERSION).tar.gz
TEMP_INSTALL_DIR:=$(shell mktemp -du -p .)

EXTRA_CFLAGS=$(shell $(PKG_CONFIG) --cflags glib-2.0,sqlite3,blkid,mount,uuid,libbsd)
EXTRA_LIBS=$(shell $(PKG_CONFIG) --libs glib-2.0,sqlite3,blkid,mount,uuid)

ifdef DEBUG
	DEBUG_FLAGS = -ggdb3 -fsanitize=address -fno-omit-frame-pointer	-O0 \
			-DDEBUG_BUILD -DSQLITE_DEBUG -DSQLITE_MEMDEBUG \
			-DSQLITE_ENABLE_EXPLAIN_COMMENTS -fsanitize-address-use-after-scope
else
	CFLAGS += -O2
endif

override CFLAGS += -D_FILE_OFFSET_BITS=64 -DVERSTRING=\"$(VERSION)\" \
	$(EXTRA_CFLAGS) $(DEBUG_FLAGS) \
	-DIS_RELEASE=$(IS_RELEASE) -D_GNU_SOURCE
LIBRARY_FLAGS += -Wl,--as-needed -latomic -lm $(EXTRA_LIBS)

# make C=1 to enable sparse
ifdef C
	CC = sparse -D__CHECKER__ -D__CHECK_ENDIAN__ -Wbitwise \
		-Wuninitialized -Wshadow -Wundef
endif

DESTDIR ?= /
PREFIX ?= /usr/local
SHAREDIR = $(PREFIX)/share
BINDIR = $(PREFIX)/bin
MANDIR = $(SHAREDIR)/man

all: $(progs)
debug:
	@echo "Deprecated, use \"make DEBUG=1\" instead please."

$(MANPAGES): %.8: markdown/%.md
	pandoc --standalone markdown/$(subst .8,,$@).md --to man -o $(subst .8,,$@).8
	pandoc --standalone markdown/$(subst .8,,$@).md --to html -o docs/$(subst .8,,$@).html

-include $(DEPENDS)
$(progs): $(OBJECTS)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(SHARED_OBJECTS) $@.o -o $@ $(LIBRARY_FLAGS)

.PHONY: test
test:
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) tests.c -o $@ $(LIBRARY_FLAGS)
	./test

install: $(install_progs) $(MANPAGES) $(ZSH_COMPLETION)
	mkdir -p -m 0755 $(DESTDIR)$(BINDIR)
	for prog in $(install_progs); do \
		install -m 0755 $$prog $(DESTDIR)$(BINDIR); \
	done
	mkdir -p -m 0755 $(DESTDIR)$(MANDIR)/man8
	for man in $(MANPAGES); do \
		install -m 0644 $$man $(DESTDIR)$(MANDIR)/man8; \
	done
	mkdir -p -m 0755 $(DESTDIR)$(SHAREDIR)/zsh/site-functions
	for completion in $(ZSH_COMPLETION); do \
		install -m 0644 $$completion $(DESTDIR)$(SHAREDIR)/zsh/site-functions; \
	done

uninstall:
	for prog in $(install_progs); do \
		rm -f $(DESTDIR)$(BINDIR)/$$prog; \
	done
	for man in $(MANPAGES); do \
		rm -f $(DESTDIR)$(MANDIR)/man8/$$man; \
	done
	for completion in $(ZSH_COMPLETION); do \
		rm -f $(DESTDIR)$(SHAREDIR)/zsh/site-functions/$${completion##*/}; \
	done

tarball: clean $(DIST_SOURCES)
	mkdir -p $(TEMP_INSTALL_DIR)/$(DIST)
	cp $(DIST_SOURCES) $(TEMP_INSTALL_DIR)/$(DIST)
	tar -C $(TEMP_INSTALL_DIR) -zcf $(DIST_TARBALL) $(DIST)
	rm -fr $(TEMP_INSTALL_DIR)

clean:
	rm -fr $(OBJECTS) $(progs) $(DIST_TARBALL) $(DEPENDS) *~

doc: $(MANPAGES)

=== debian/changelog ===
duperemove (0.15.2-1) unstable; urgency=medium

  * Salvage Package, set tracker as maintainer, myself as uploader
    (Closes: #1109601)
  * New upstream release 0.15.2 (Closes: #1056946)
    * all Debian patches have become obsolete with this
  * Standards-Version: 4.7.2 (no changes necessary)
  * install show-shared-extents manually (Upstream #388)
  * Patch upstream Makefile to endure reproducibility (Upstream #390)

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Wed, 24 Sep 2025 11:47:55 +0200

=== debian/control ===
Source: duperemove
Maintainer: Duperemove Maintainers <duperemove@packages.debian.org>
Uploaders: Marc Haber <mh+debian-packages@zugschlus.de>
Section: admin
Priority: optional
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch: libbsd-dev, libglib2.0-dev, libsqlite3-dev, libxxhash-dev
Standards-Version: 4.7.2
Rules-Requires-Root: binary-targets
Homepage: https://markfasheh.github.io/duperemove/
Vcs-Git: https://salsa.debian.org/debian/duperemove.git
Vcs-Browser: https://salsa.debian.org/debian/duperemove

Package: duperemove
Architecture: linux-any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: btrfs-progs
Description: extent-based deduplicator for file systems
 Duperemove is a tool for finding duplicated extents and submitting them for
 deduplication.  When given a list of files it will hash their contents on a
 block by block basis and compare those hashes to each other, finding and
 categorizing extents that match each other.
 .
 On BTRFS and, experimentally, XFS, it can then reflink such extents in a
 race-free way.  Unlike hardlink-based solutions, affected files appear
 independent in any way other than reduced disk space used.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

=== debian/watch ===
version=4
opts= \
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/duperemove-$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
  https://github.com/markfasheh/duperemove/tags .*/v?(\d\S+)\.tar\.gz
